// SDIView.cpp : implementation of the CSDIView class
//

#include "stdafx.h"
#include "SDI.h"

#include "SDIDoc.h"
#include "SDIView.h"
#include ".\sdiview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSDIView

IMPLEMENT_DYNCREATE(CSDIView, CView)

BEGIN_MESSAGE_MAP(CSDIView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_MESSAGE(WM_USERAPPLY, OnUserApply)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

// CSDIView construction/destruction

CSDIView::CSDIView()
: m_strMsg(_T(""))
{
	// TODO: add construction code here
	m_pDlg = new CSdiDialog(this);
	m_pDlg->m_check = FALSE;
    m_pDlg->m_edit = "hello there";
	m_pDlg->m_radio = 1;
	m_dlg.m_check = FALSE;
    m_dlg.m_edit = "hello there";
	m_dlg.m_radio = 1;

}

CSDIView::~CSDIView()
{
	delete m_pDlg;
}

BOOL CSDIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CSDIView drawing

void CSDIView::OnDraw(CDC* pDC)
{
	CSDIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	CSize szText = pDC->GetTextExtent("M");
	int nOffset = 0;
	pDC->TextOut(0,nOffset,"Left Click for Modal");
	nOffset += szText.cy;
	pDC->TextOut(0,nOffset,"Right Click for Modeless");
	nOffset += 2 * szText.cy;
	CString nextToken;
	int nPos = 0;
	while ((nextToken = m_strMsg.Tokenize("\n\r", nPos)) != "") {
		pDC->TextOut(0,nOffset,nextToken);
		nOffset += szText.cy;
	}
}


// CSDIView printing

BOOL CSDIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSDIView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSDIView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CSDIView diagnostics

#ifdef _DEBUG
void CSDIView::AssertValid() const
{
	CView::AssertValid();
}

void CSDIView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSDIDoc* CSDIView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDIDoc)));
	return (CSDIDoc*)m_pDocument;
}
#endif //_DEBUG


// CSDIView message handlers

void CSDIView::OnLButtonDown(UINT nFlags, CPoint point)
{
	 
    CString msg;
    if (m_dlg.DoModal() == IDOK)
    {
        msg = "You clicked OK\r\n";
    }
    else
    {
        msg = "You cancelled\r\n";
    }
	msg += m_dlg.BuildMessage();
    AfxMessageBox (msg);
}

LRESULT CSDIView::OnUserApply(WPARAM wParam, LPARAM lParam)
{
	m_strMsg = m_pDlg->BuildMessage();
	TRACE("Msg: %s\n", m_strMsg);
	Invalidate();
	return 0L;
}

void CSDIView::OnRButtonDown(UINT nFlags, CPoint point)
{
	if (m_pDlg->GetSafeHwnd() == 0) {
		TRACE("Creating Dialog\n");
		if (!m_pDlg->Create()) {
			TRACE("Failed to create dialog\n");
		}
	}
}

void CSDIView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == 'C') {
		TRACE("Destroying Dialog\n");
		m_pDlg->DestroyWindow();
	}
}
