// SdiDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SDI.h"
#include "SdiDialog.h"
#include ".\sdidialog.h"


// CSdiDialog dialog

IMPLEMENT_DYNAMIC(CSdiDialog, CDialog)

CSdiDialog::CSdiDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSdiDialog::IDD, pParent)
{
	Init();
	m_pView = NULL;
}

CSdiDialog::CSdiDialog(CView* pView)
{
	Init();
	m_pView = pView;
}

CSdiDialog::~CSdiDialog()
{
}

void CSdiDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK1, m_check);
	DDX_Text(pDX, IDC_EDIT1, m_edit);
	DDX_Control(pDX, IDC_LIST1, m_listbox);
	DDX_Radio(pDX, IDC_RADIO1, m_radio);
	DDX_LBString(pDX, IDC_LIST1, m_strListbox);
}


BEGIN_MESSAGE_MAP(CSdiDialog, CDialog)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_APPLY, OnBnClickedApply)
END_MESSAGE_MAP()


// CSdiDialog message handlers

BOOL CSdiDialog::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	CPoint pntTopLeft(50,200);
	CRect rectWindow;
	GetWindowRect(&rectWindow);
	
	if (m_pView == NULL) {
		SetWindowText("Modal Dialog");
	} else {
		SetWindowText("Modeless Dialog");
		pntTopLeft.x += rectWindow.Width();
	}

	rectWindow = rectWindow + pntTopLeft;
	this->MoveWindow(rectWindow);

     m_listbox.AddString("First String");
     m_listbox.AddString("Second String");
     m_listbox.AddString("Yet Another String");
     m_listbox.AddString("String Number Four");
     m_listbox.SetCurSel(2);

	 if (m_pView == NULL) {
		 CButton* pApply = (CButton*) GetDlgItem(IDC_APPLY);
		 pApply->ShowWindow(SW_HIDE);
	 }

 


    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

void CSdiDialog::OnOK()
{
     int index = m_listbox.GetCurSel();
     if (index != LB_ERR)
     {
          m_listbox.GetText(index, m_selected);
     }
     else
     {
          m_selected = "";
     }
	
	 if (m_pView != NULL) {
		 OnBnClickedApply();
		 DestroyWindow();
	 } else {
	    CDialog::OnOK();
	 }
}

void CSdiDialog::OnCancel()
{
     m_selected = "";

	 if (m_pView != NULL) {
		 DestroyWindow();
	 } else {
	    CDialog::OnCancel();
	 }
}

void CSdiDialog::OnBnClickedCheck1()
{
	// TODO: Add your control notification handler code here
	AfxMessageBox("Clicked");
}

bool CSdiDialog::Init(void)
{
    m_check = FALSE;
    m_edit = _T("");
    m_radio = 0;
    m_selected = _T("");
	m_strListbox = _T("");

	return true;
}

BOOL CSdiDialog::Create(void)
{
	return CDialog::Create(CSdiDialog::IDD);
}

void CSdiDialog::OnBnClickedApply()
{
	if (m_pView != NULL) {
		UpdateData(TRUE);
		m_pView->PostMessage(WM_USERAPPLY);
	}
}

CString CSdiDialog::BuildMessage(void)
{
	CString msg;
	msg = "Edit box is: ";
    msg += m_edit;
    msg += "\r\nList Selection: ";
    msg += m_strListbox;

    msg += "\r\nRadio Selection: ";

    switch (m_radio)
    {
    case 0:
        msg += "Radio 0";
        break;
    case 1:
        msg += "Radio 1";
        break;
    case 2:
        msg += "Radio 2";
        break;
    default:
        msg += "none";
        break;
    }

	return msg;
}
